/**
 * @brief Compatibility layer for different `printf` implementations.
 */
#ifndef STA_PRINTF_HPP
#define STA_PRINTF_HPP

#include <sta/config.hpp>

#if !defined(STA_PRINTF_USE_STDLIB) && !defined(STA_PRINTF_USE_MPALAND)
#  error "No printf implementation chosen!"
#endif // !STA_PRINTF_USE_STDLIB && !STA_PRINTF_USE_MPALAND


#ifdef STA_PRINTF_USE_STDLIB
#  include <cstdio>
#endif // STA_PRINTF_USE_STDLIB
#ifdef STA_PRINTF_USE_MPALAND
#  include <printf.h>
#endif // STA_PRINTF_USE_MPALAND


#endif // STA_PRINTF_HPP
